package ctbrec.variableexpansion.functions;

import ctbrec.variableexpansion.VarArgsFunction;

import java.time.ZonedDateTime;
import java.time.format.DateTimeFormatter;
import java.util.Optional;

public class Format implements VarArgsFunction<Object, String> {
    @Override
    public String apply(Object[] params) {
        return Optional.ofNullable(params).map(p -> {
                    String format = "yyyy-MM-dd_HH-mm-ss";
                    if (p.length > 1) {
                        format = (String) p[1];
                    }
                    ZonedDateTime zdt;
                    if (p[0] instanceof String date) {
                        zdt = ZonedDateTime.parse(date);
                    } else {
                        zdt = (ZonedDateTime) p[0];
                    }
                    return DateTimeFormatter.ofPattern(format).format(zdt);
                })
                .orElse("");
    }
}
